/**
 * Getting Started with Capture.
 * 
 * Reading and displaying an image from an attached Capture device. 
 */

import processing.video.*;

double Si = 0;
double abweichung =0;


Capture cam;

int[] pix;

int CAMBREITE = 640; 
int CAMHOEHE  = 480; 


void setup() 
{
  //size(640, 480);
  size(1300, 700);

  String[] cameras = Capture.list();

  if (cameras == null) {
    println("Failed to retrieve the list of available cameras, will try the default...");
    cam = new Capture(this,CAMBREITE, CAMHOEHE);
  } if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(i+cameras[i]);
    }

    // The camera can be initialized directly using an element
    // from the array returned by list():
    cam = new Capture(this, cameras[0]);
    // Or, the settings can be defined based on the text in the list
    //cam = new Capture(this, 640, 480, "Built-in iSight", 30);
    
    // Start capturing the images from the camera
    cam.start();
  }
}

void draw() 
{
  //fill(0);
  //rect(0,0,displayWidth,displayHeight);

  if (cam.available() == true) 
  {
        cam.read();
    
        image(cam,0,0);
        cam.updatePixels();
        pix = cam.pixels;
        int ii=0;
        
        double schwerpunkt  = 0;
        double summe_echtes_rot = 0;

        noStroke();
        for(int i=0;i<CAMHOEHE;i++)
        {

          
              for(int k=0;k<CAMBREITE;k++)
              {
                  int rot   = (int)red(pix[ii]);
                  int gruen = (int)green(pix[ii]);
                  int blau  = (int)blue(pix[ii]);
                  
                  int echtes_rot = rot -blau -gruen;
                  if(echtes_rot<0)
                      echtes_rot =0;
                  echtes_rot *=7;
                  if(echtes_rot>255)
                      echtes_rot = 255;
                  
                  fill(echtes_rot,echtes_rot,echtes_rot);
                  
                  rect(k*1+640,i*1,1,1);
                  
                  schwerpunkt  += k*echtes_rot;
                  summe_echtes_rot += echtes_rot;
                  
                  ii++;
              }
              if(summe_echtes_rot == 0.0)
              {
                 Si += (CAMBREITE/2);
              }
              else 
              {
                 Si += (schwerpunkt/summe_echtes_rot);
              }
        }
        Si /=CAMHOEHE;
        //println(Si);
    
  }
  stroke(255,0,0);
  line((float)Si+CAMBREITE,0,(float)Si+CAMBREITE,360);
  abweichung= (CAMBREITE/2) - Si;
  
  fill(0);
  rect(0,490,displayWidth,300);
  
  noStroke();
  fill(255,100,100);
  textSize(40);
  text("Regelabw. in Pixel: "+abweichung,100,530);
  
  println("Abweichung: "+ abweichung);
  // The following does the same as the above image() line, but 
  // is faster when just drawing the image without any additional 
  // resizing, transformations, or tint.
  //set(0, 0, cam);
}
